
ROTATE_X equ 0
ROTATE_Y equ 1
ROTATE_Z equ 2

GET_X equ 0
GET_Y equ 1
GET_Z equ 2

.code

nwGlobalRotation proc uses esi edi ebx lpfMat4X:dword,lpfMat4Y:dword,lpfMat4Z:dword,lpfMat4Point:dword
	;Originally created by NightWare at www.masmforum.com
	
	; eax = OFFSET of X rotation matrix ) must be 4*4 matrix (even if we only use 3*3)
	; ebx = OFFSET of Y rotation matrix )
	; ecx = OFFSET of Z rotation matrix )
	; edx = OFFSET of the point to calc
	
	mov eax,lpfMat4X
	mov ebx,lpfMat4Y
	mov ecx,lpfMat4Z
	mov edx,lpfMat4Point
	
	movaps XMM0,OWORD PTR [ecx]
	movaps XMM1,OWORD PTR [ecx+4*DWORD]
	movaps XMM2,OWORD PTR [ecx+8*DWORD]
	movaps XMM5,OWORD PTR [eax]
	movaps XMM6,OWORD PTR [eax+4*DWORD]
	movaps XMM7,OWORD PTR [ecx+8*DWORD]
	movaps XMM3,XMM0
	movaps XMM4,XMM0
	shufps XMM0,XMM0,0C0h
	shufps XMM3,XMM3,0D5h
	shufps XMM4,XMM4,0EAh
	mulps XMM0,XMM5
	mulps XMM3,XMM6
	mulps XMM4,XMM7
	addps XMM0,XMM3
	addps XMM0,XMM4
	movaps XMM3,XMM1
	movaps XMM4,XMM1
	shufps XMM1,XMM1,0C0h
	shufps XMM3,XMM3,0D5h
	shufps XMM4,XMM4,0EAh
	mulps XMM1,XMM5
	mulps XMM3,XMM6
	mulps XMM4,XMM7
	addps XMM1,XMM3
	addps XMM1,XMM4
	movaps XMM3,XMM2
	movaps XMM4,XMM2
	shufps XMM2,XMM2,0C0h
	shufps XMM3,XMM3,0D5h
	shufps XMM4,XMM4,0EAh
	mulps XMM2,XMM5
	mulps XMM3,XMM6
	mulps XMM4,XMM7
	addps XMM2,XMM3
	addps XMM2,XMM4
	movaps XMM6,OWORD PTR [ebx]
	movaps XMM7,OWORD PTR [ebx+4*DWORD]
	movaps XMM5,OWORD PTR [ebx+8*DWORD]
	movaps XMM3,XMM6
	movaps XMM4,XMM6
	shufps XMM6,XMM6,0C0h
	shufps XMM3,XMM3,0D5h
	shufps XMM4,XMM4,0EAh
	mulps XMM6,XMM0
	mulps XMM3,XMM1
	mulps XMM4,XMM2
	addps XMM6,XMM3
	addps XMM6,XMM4
	movaps XMM3,XMM7
	movaps XMM4,XMM7
	shufps XMM7,XMM7,0C0h
	shufps XMM3,XMM3,0D5h
	shufps XMM4,XMM4,0EAh
	mulps XMM7,XMM0
	mulps XMM3,XMM1
	mulps XMM4,XMM2
	addps XMM7,XMM3
	addps XMM7,XMM4
	movaps XMM3,XMM5
	movaps XMM4,XMM5
	shufps XMM5,XMM5,0C0h
	shufps XMM3,XMM3,0D5h
	shufps XMM4,XMM4,0EAh
	mulps XMM5,XMM0
	mulps XMM3,XMM1
	mulps XMM4,XMM2
	addps XMM4,XMM5
	addps XMM4,XMM3
	; here, the global rotation matrix is in XMM6, XMM7 and XMM4
	
	
	;
	; here, we transpose the global rotation matrix (in XMM6, XMM7 et XMM4) to increase speed calc after...
	;
	movaps XMM5,XMM6
	movlhps XMM5,XMM7
	movhlps XMM7,XMM6
	movaps XMM6,XMM5
	shufps XMM5,XMM4,0C8h
	shufps XMM6,XMM4,0DDh
	shufps XMM7,XMM4,0E8h
	; here, the global rotation matrix is in XMM5, XMM6 and XMM7
	
	
	;
	; here, we calc a simple point (with our matrix in XMM5, XMM6 and XMM7)
	; after the global matrix is calculated, you just need to repeat this operation for every points
	;
	movaps XMM0,OWORD PTR [edx]
	movaps XMM1,XMM0
	movaps XMM2,XMM0
	shufps XMM0,XMM0,000h
	shufps XMM1,XMM1,055h
	shufps XMM2,XMM2,0AAh
	mulps XMM0,XMM5
	mulps XMM1,XMM6
	mulps XMM2,XMM7
	addps XMM0,XMM1
	addps XMM0,XMM2
	; here, XMM0 = _,newZ,newY,newX
	
	ret
nwGlobalRotation endp

fShowMatrix4x4 proc uses esi lpMat:dword,lpText:dword
	LOCAL buff[256]:dword
	local buff2[256]:dword
	LOCAL q:qword
	LOCAL d:dword
	
	mov esi,lpMat
	invoke memfill,addr buff2,1024,0
	
	xor ecx,ecx
	mov d,ecx
	loop_cell:
	pushad
		fld dword ptr[esi+ecx*4]
		fstp q
		invoke FloatToStr2,q,addr buff
		invoke lstrcat,addr buff2,addr buff
		invoke lstrcat,addr buff2,CADD(" ")
		inc d
		.if d==4
			push 0
			pop d
			invoke lstrlen,addr buff2
			lea ecx,buff2
			add ecx,eax
			mov ax,0d0ah
			mov [ecx],ax
		.endif
	popad
	inc ecx
	cmp ecx,16
	jl loop_cell
	
	invoke MessageBox,0,addr buff2,lpText,MB_OK
	
	ret
fShowMatrix4x4 endp

fFillMatrix4f proc uses esi lpfMat4:dword,nIndex:dword,value:dword
	
	mov esi,lpfMat4
	mov ecx,nIndex
	mov eax,value
	mov [esi+ecx*4],eax
	
	ret
fFillMatrix4f endp

fGetMatrix4f proc uses esi lpfMat4:dword,nIndex:dword
	
	mov esi,lpfMat4
	mov ecx,nIndex
	mov eax,[esi+ecx*4]
	
	ret
fGetMatrix4f endp

fLoadMatrix4fToFPU proc uses esi lpfMat4f:dword,nIndex:dword
	
	mov esi,lpfMat4f
	mov ecx,nIndex
	
	fld dword ptr[esi+ecx*4]
	
	ret
fLoadMatrix4fToFPU endp

fMat4fLoadZero proc uses esi lpfMat4f:dword
	
	mov esi,lpfMat4f
	
	xor ecx,ecx
	loop_fill:
	pushad
		invoke fFillMatrix4f,esi,ecx,CFLT(0.0)
	popad
	inc ecx
	cmp ecx,16
	jl loop_fill
	
	ret
fMat4fLoadZero endp

fMat4fLoadIdentity proc uses esi lpfMat4f:dword
	
	invoke fFillMatrix4f,lpfMat4f,0,CFLT(1.0)
	invoke fFillMatrix4f,lpfMat4f,1,CFLT(0.0)
	invoke fFillMatrix4f,lpfMat4f,2,CFLT(0.0)
	invoke fFillMatrix4f,lpfMat4f,3,CFLT(0.0)
	
	invoke fFillMatrix4f,lpfMat4f,4,CFLT(0.0)
	invoke fFillMatrix4f,lpfMat4f,5,CFLT(1.0)
	invoke fFillMatrix4f,lpfMat4f,6,CFLT(0.0)
	invoke fFillMatrix4f,lpfMat4f,7,CFLT(0.0)
	
	invoke fFillMatrix4f,lpfMat4f,8,CFLT(0.0)
	invoke fFillMatrix4f,lpfMat4f,9,CFLT(0.0)
	invoke fFillMatrix4f,lpfMat4f,10,CFLT(1.0)
	invoke fFillMatrix4f,lpfMat4f,11,CFLT(0.0)
	
	invoke fFillMatrix4f,lpfMat4f,12,CFLT(0.0)
	invoke fFillMatrix4f,lpfMat4f,13,CFLT(0.0)
	invoke fFillMatrix4f,lpfMat4f,14,CFLT(0.0)
	invoke fFillMatrix4f,lpfMat4f,15,CFLT(1.0)
	
	ret
fMat4fLoadIdentity endp

fMat4fTranslate proc uses esi lpfMat:dword,x:real4,y:real4,z:real4
	LOCAL ftmp:real4
	
	;this->matrix[12]=(this->matrix[0]*x)+(this->matrix[4]*y)+(this->matrix[8] *z)+(this->matrix[12]);
	invoke fLoadMatrix4fToFPU,lpfMat,0
	push x
		fmul dword ptr[esp]
		fstp dword ptr[esp]
	pop ftmp
	invoke fLoadMatrix4fToFPU,lpfMat,4
	push y
		fmul dword ptr[esp]
		fadd ftmp
		fstp dword ptr[esp]
	pop ftmp
	invoke fLoadMatrix4fToFPU,lpfMat,8
	push z
		fmul dword ptr[esp]
		fadd ftmp
		fstp dword ptr[esp]
	pop ftmp
	invoke fLoadMatrix4fToFPU,lpfMat,12
	push ftmp
		fadd dword ptr[esp]
		fstp dword ptr[esp]
	pop ftmp
	invoke fFillMatrix4f,lpfMat,12,ftmp
	;this->matrix[13]=(this->matrix[1]*x)+(this->matrix[5]*y)+(this->matrix[9] *z)+(this->matrix[13]);
	invoke fLoadMatrix4fToFPU,lpfMat,1
	push x
		fmul dword ptr[esp]
		fstp dword ptr[esp]
	pop ftmp
	invoke fLoadMatrix4fToFPU,lpfMat,5
	push y
		fmul dword ptr[esp]
		fadd ftmp
		fstp dword ptr[esp]
	pop ftmp
	invoke fLoadMatrix4fToFPU,lpfMat,9
	push z
		fmul dword ptr[esp]
		fadd ftmp
		fstp dword ptr[esp]
	pop ftmp
	invoke fLoadMatrix4fToFPU,lpfMat,13
	push ftmp
		fadd dword ptr[esp]
		fstp dword ptr[esp]
	pop ftmp
	invoke fFillMatrix4f,lpfMat,13,ftmp
	;this->matrix[14]=(this->matrix[2]*x)+(this->matrix[6]*y)+(this->matrix[10]*z)+(this->matrix[14]);
	invoke fLoadMatrix4fToFPU,lpfMat,2
	push x
		fmul dword ptr[esp]
		fstp dword ptr[esp]
	pop ftmp
	invoke fLoadMatrix4fToFPU,lpfMat,6
	push y
		fmul dword ptr[esp]
		fadd ftmp
		fstp dword ptr[esp]
	pop ftmp
	invoke fLoadMatrix4fToFPU,lpfMat,10
	push z
		fmul dword ptr[esp]
		fadd ftmp
		fstp dword ptr[esp]
	pop ftmp
	invoke fLoadMatrix4fToFPU,lpfMat,14
	push ftmp
		fadd dword ptr[esp]
		fstp dword ptr[esp]
	pop ftmp
	invoke fFillMatrix4f,lpfMat,14,ftmp
	
	ret
fMat4fTranslate endp

fMat4fMulProcess proc uses esi edi M1:dword,M2:dword,m10:dword,m11:dword,m20:dword,m21:dword,m30:dword,m31:dword,m40:dword,m41:dword
	LOCAL ftmp:dword
	
	mov esi,M1
	mov edi,M2
	
	invoke fLoadMatrix4fToFPU,esi,m10
	invoke fLoadMatrix4fToFPU,edi,m11
	fmul st,st(1)
	push 0
		fstp dword ptr[esp]
	pop ftmp
	finit
	invoke fLoadMatrix4fToFPU,esi,m20
	invoke fLoadMatrix4fToFPU,edi,m21
	fmul st,st(1)
	push 0
		fadd ftmp
		fstp dword ptr[esp]
	pop ftmp
	finit
	invoke fLoadMatrix4fToFPU,esi,m30
	invoke fLoadMatrix4fToFPU,edi,m31
	fmul st,st(1)
	push 0
		fadd ftmp
		fstp dword ptr[esp]
	pop ftmp
	finit
	invoke fLoadMatrix4fToFPU,esi,m40
	invoke fLoadMatrix4fToFPU,edi,m41
	fmul st,st(1)
	push 0
		fadd ftmp
		fstp dword ptr[esp]
	pop ftmp
	finit
	
	mov eax,ftmp
	
	ret
fMat4fMulProcess endp

fMat4fMulMatrix proc uses esi edi lpMat4fDestination:dword,lpMat4fM1:dword,lpMat4fM2:dword
	LOCAL mtmp[16]:dword
	LOCAL ftmp:real4
	
	mov esi,lpMat4fM1
	mov edi,lpMat4fM2
	
	;invoke fMat4fLoadZero,addr mtmp
	
	;result.matrix[0] = (m1.matrix[0]*m2.matrix[0]) + (m1.matrix[4]*m2.matrix[1]) +(m1.matrix[8]*m2.matrix[2]) +(m1.matrix[12]*m2.matrix[3]);
	invoke fMat4fMulProcess,esi,edi,0,0,4,1,8,2,12,3
	invoke fFillMatrix4f,addr mtmp,0,eax
	;result.matrix[4] = (m1.matrix[0]*m2.matrix[4]) + (m1.matrix[4]*m2.matrix[5]) +(m1.matrix[8]*m2.matrix[6]) +(m1.matrix[12]*m2.matrix[7]);
	invoke fMat4fMulProcess,esi,edi,0,4,4,5,8,6,12,7
	invoke fFillMatrix4f,addr mtmp,4,eax
	;result.matrix[8] = (m1.matrix[0]*m2.matrix[8]) + (m1.matrix[4]*m2.matrix[9]) +(m1.matrix[8]*m2.matrix[10])+(m1.matrix[12]*m2.matrix[11]);
	invoke fMat4fMulProcess,esi,edi,0,8,4,9,8,10,12,11
	invoke fFillMatrix4f,addr mtmp,8,eax
	;result.matrix[12]= (m1.matrix[0]*m2.matrix[12])+ (m1.matrix[4]*m2.matrix[13])+(m1.matrix[8]*m2.matrix[14])+(m1.matrix[12]*m2.matrix[15]);
	invoke fMat4fMulProcess,esi,edi,0,12,4,13,8,14,12,15
	invoke fFillMatrix4f,addr mtmp,12,eax
	
	;result.matrix[1] = (m1.matrix[1]*m2.matrix[0]) +(m1.matrix[5]*m2.matrix[1]) +(m1.matrix[9]*m2.matrix[2]) +(m1.matrix[13]*m2.matrix[3]);
	invoke fMat4fMulProcess,esi,edi,1,0,5,1,9,2,13,3
	invoke fFillMatrix4f,addr mtmp,1,eax
	;result.matrix[5] = (m1.matrix[1]*m2.matrix[4]) +(m1.matrix[5]*m2.matrix[5]) +(m1.matrix[9]*m2.matrix[6]) +(m1.matrix[13]*m2.matrix[7]);
	invoke fMat4fMulProcess,esi,edi,1,4,5,5,9,6,13,7
	invoke fFillMatrix4f,addr mtmp,5,eax
	;result.matrix[9] = (m1.matrix[1]*m2.matrix[8]) +(m1.matrix[5]*m2.matrix[9]) +(m1.matrix[9]*m2.matrix[10])+(m1.matrix[13]*m2.matrix[11]);
	invoke fMat4fMulProcess,esi,edi,1,8,5,9,9,10,13,11
	invoke fFillMatrix4f,addr mtmp,9,eax
	;result.matrix[13]= (m1.matrix[1]*m2.matrix[12])+(m1.matrix[5]*m2.matrix[13])+(m1.matrix[9]*m2.matrix[14])+(m1.matrix[13]*m2.matrix[15]);
	invoke fMat4fMulProcess,esi,edi,1,12,5,13,9,14,13,15
	invoke fFillMatrix4f,addr mtmp,13,eax
	
	;result.matrix[2] = (m1.matrix[2]*m2.matrix[0]) +(m1.matrix[6]*m2.matrix[1]) +(m1.matrix[10]*m2.matrix[2]) +(m1.matrix[14]*m2.matrix[3]);
	invoke fMat4fMulProcess,esi,edi,2,0,6,1,10,2,14,3
	invoke fFillMatrix4f,addr mtmp,2,eax
	;result.matrix[6] = (m1.matrix[2]*m2.matrix[4]) +(m1.matrix[6]*m2.matrix[5]) +(m1.matrix[10]*m2.matrix[6]) +(m1.matrix[14]*m2.matrix[7]);
	invoke fMat4fMulProcess,esi,edi,2,4,6,5,10,6,14,7
	invoke fFillMatrix4f,addr mtmp,6,eax
	;result.matrix[10]= (m1.matrix[2]*m2.matrix[8]) +(m1.matrix[6]*m2.matrix[9]) +(m1.matrix[10]*m2.matrix[10])+(m1.matrix[14]*m2.matrix[11]);
	invoke fMat4fMulProcess,esi,edi,2,8,6,9,10,10,14,11
	invoke fFillMatrix4f,addr mtmp,10,eax
	;result.matrix[14]= (m1.matrix[2]*m2.matrix[12])+(m1.matrix[6]*m2.matrix[13])+(m1.matrix[10]*m2.matrix[14])+(m1.matrix[14]*m2.matrix[15]);
	invoke fMat4fMulProcess,esi,edi,2,12,6,13,10,14,14,15
	invoke fFillMatrix4f,addr mtmp,14,eax
	
	;result.matrix[3] = (m1.matrix[3]*m2.matrix[0]) +(m1.matrix[7]*m2.matrix[1]) +(m1.matrix[11]*m2.matrix[2]) +(m1.matrix[15]*m2.matrix[3]);
	invoke fMat4fMulProcess,esi,edi,3,0,7,1,11,2,15,3
	invoke fFillMatrix4f,addr mtmp,3,eax
	;result.matrix[7] = (m1.matrix[3]*m2.matrix[4]) +(m1.matrix[7]*m2.matrix[5]) +(m1.matrix[11]*m2.matrix[6]) +(m1.matrix[15]*m2.matrix[7]);
	invoke fMat4fMulProcess,esi,edi,3,4,7,5,11,6,15,7
	invoke fFillMatrix4f,addr mtmp,7,eax
	;result.matrix[11]= (m1.matrix[3]*m2.matrix[8]) +(m1.matrix[7]*m2.matrix[9]) +(m1.matrix[11]*m2.matrix[10])+(m1.matrix[15]*m2.matrix[11]);
	invoke fMat4fMulProcess,esi,edi,3,8,7,9,11,10,15,11
	invoke fFillMatrix4f,addr mtmp,11,eax
	;result.matrix[15]= (m1.matrix[3]*m2.matrix[12])+(m1.matrix[7]*m2.matrix[13])+(m1.matrix[11]*m2.matrix[14])+(m1.matrix[15]*m2.matrix[15]);
	invoke fMat4fMulProcess,esi,edi,3,12,7,13,11,14,15,15
	invoke fFillMatrix4f,addr mtmp,15,eax
	
	invoke MemCopy,addr mtmp,lpMat4fDestination,16*4
	
	ret
fMat4fMulMatrix endp

fMat4fRotate proc uses esi edi lpfMat4f:dword,nOrder:dword,Degree:real4
	LOCAL mtmp[16]:dword
	LOCAL tmpx,tmpy,tmpz:dword
	LOCAL msin,mcos,mmsin,mmcos:dword
	
	invoke fGetMatrix4f,lpfMat4f,12
	mov tmpx,eax
	invoke fGetMatrix4f,lpfMat4f,13
	mov tmpy,eax
	invoke fGetMatrix4f,lpfMat4f,14
	mov tmpz,eax
	
	invoke fFillMatrix4f,lpfMat4f,12,CFLT(0.0)
	invoke fFillMatrix4f,lpfMat4f,13,CFLT(0.0)
	invoke fFillMatrix4f,lpfMat4f,14,CFLT(0.0)
	
	invoke fMat4fLoadIdentity,addr mtmp
	
	fld Degree
	fmul CFLT(0.0174532)
	fsincos
	fstp msin
	fstp mcos
	
	fld msin
	fchs
	fstp mmsin
	
	fld mcos
	fchs
	fstp mmcos
	
	.if nOrder==ROTATE_X
		invoke fFillMatrix4f,addr mtmp,5,mcos
		invoke fFillMatrix4f,addr mtmp,6,mmsin
		invoke fFillMatrix4f,addr mtmp,9,msin
		invoke fFillMatrix4f,addr mtmp,10,mcos
	.elseif nOrder==ROTATE_Y
		invoke fFillMatrix4f,addr mtmp,0,mcos
		invoke fFillMatrix4f,addr mtmp,2,msin
		invoke fFillMatrix4f,addr mtmp,8,mmsin
		invoke fFillMatrix4f,addr mtmp,10,mcos
	.elseif nOrder==ROTATE_Z
		invoke fFillMatrix4f,addr mtmp,0,mcos
		invoke fFillMatrix4f,addr mtmp,1,mmsin
		invoke fFillMatrix4f,addr mtmp,4,msin
		invoke fFillMatrix4f,addr mtmp,5,mcos
	.endif
	
	
	invoke fMat4fMulMatrix,lpfMat4f,lpfMat4f,addr mtmp
	
	invoke fFillMatrix4f,lpfMat4f,12,tmpx
	invoke fFillMatrix4f,lpfMat4f,13,tmpy
	invoke fFillMatrix4f,lpfMat4f,14,tmpz
	
	
	ret
fMat4fRotate endp

fMat4fGetResult proc uses esi lpMat4f:dword,nOrder:dword
	LOCAL tmp:real4
	LOCAL p:dword
	
	push nOrder
	pop p
	
	shl p,2
	
	invoke fLoadMatrix4fToFPU,lpMat4f,p
	inc p
	invoke fLoadMatrix4fToFPU,lpMat4f,p
	inc p
	fadd st,st(1)
	invoke fLoadMatrix4fToFPU,lpMat4f,p
	inc p
	fadd st,st(1)
	invoke fLoadMatrix4fToFPU,lpMat4f,p
	fadd st,st(1)
	fstp tmp
	finit
	
	mov eax,tmp
	
	ret
fMat4fGetResult endp